function model=kplsdcv(X,y, cycles,nts, opt)

Ypred=zeros(nts*cycles,1);
Ytrue=zeros(nts*cycles,1);


for i=1:cycles
    a=randperm(size(X,1)); 
    Xtr=X(a(nts+1:end),:); 
    Ytr=y(a(nts+1:end));
    Xts=X(a(1:nts),:);
    Yts=y(a(1:nts));
    
    Ytrue((i-1)*nts+1:i*nts)=Yts;
    
    mi=kpls_cv(Xtr, Ytr, opt); 
    pi=kpls_pred(Xts, Yts, mi.OptModel);
    Ypred((i-1)*nts+1:i*nts)=pi.Ypred;
end

model.Ypred=Ypred; 
model.Ytrue=Ytrue; 
rmsep=sqrt(sum((Ypred-Ytrue).^2)/size(Ytrue,1));
bias=sum(Ypred-Ytrue)/size(Ytrue,1);
vy=sum((Ytrue-repmat(mean(Ytrue), size(Ytrue,1),1)).^2);
r2=1-(sum((Ypred-Ytrue).^2)./vy);
model.rmsep=rmsep; 
model.bias=bias; 
model.q2=r2;
    
    